Subject: Re: [PATCH v4 0/8] Avoid cache trashing on clearing huge/gigantic page

From: Andrew Morton <[email-masked]>
Date: Thu, 13 Sep 2012 16:05:06 -0700

On Mon, 20 Aug 2012 16:52:29 +0300
"Kirill A. Shutemov" <[email-masked]> wrote:

> Clearing a 2MB huge page will typically blow away several levels of CPU
> caches.  To avoid this only cache clear the 4K area around the fault
> address and use a cache avoiding clears for the rest of the 2MB area.
> 
> This patchset implements cache avoiding version of clear_page only for
> x86. If an architecture wants to provide cache avoiding version of
> clear_page it should to define ARCH_HAS_USER_NOCACHE to 1 and implement
> clear_page_nocache() and clear_user_highpage_nocache().

Patchset looks nice to me, but the changelogs are terribly short of
performance measurements.  For this sort of change I do think it is
important that pretty exhaustive testing be performed, and that the
results (or a readable summary of them) be shown.  And that testing
should be designed to probe for slowdowns, not just the speedups!